<?php

namespace App\Entity\Case;

use App\Repository\Case\MonthlyCaseNoteRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Types\UuidType;
use Symfony\Component\Uid\Uuid;

#[ORM\Entity(repositoryClass: MonthlyCaseNoteRepository::class)]
class MonthlyCaseNote
{
    #[ORM\Id]
    #[ORM\Column(type: UuidType::NAME, unique: true)]
    #[ORM\GeneratedValue(strategy: 'CUSTOM')]
    #[ORM\CustomIdGenerator(class: 'doctrine.uuid_generator')]
    private ?Uuid $id = null;

    #[ORM\Column(type: Types::TEXT, nullable: true)]
    private ?string $reason = null;

    #[ORM\Column(type: Types::TEXT, nullable: true)]
    private ?string $familyStrength = null;

    #[ORM\Column(type: Types::TEXT, nullable: true)]
    private ?string $recAndProgress = null;

    #[ORM\ManyToOne(inversedBy: 'monthlyCaseNotes')]
    #[ORM\JoinColumn(nullable: false)]
    private ?MemberCase $memberCase = null;

    #[ORM\Column(type: Types::DATE_MUTABLE)]
    private ?\DateTimeInterface $date = null;

    #[ORM\Column(type: Types::DATE_MUTABLE)]
    private ?\DateTimeInterface $nextVisit = null;

    public function getId(): ?Uuid
    {
        return $this->id;
    }

    public function getReason(): ?string
    {
        return $this->reason;
    }

    public function setReason(?string $reason): static
    {
        $this->reason = $reason;

        return $this;
    }

    public function getFamilyStrength(): ?string
    {
        return $this->familyStrength;
    }

    public function setFamilyStrength(?string $familyStrength): static
    {
        $this->familyStrength = $familyStrength;

        return $this;
    }

    public function getRecAndProgress(): ?string
    {
        return $this->recAndProgress;
    }

    public function setRecAndProgress(?string $recAndProgress): static
    {
        $this->recAndProgress = $recAndProgress;

        return $this;
    }

    public function getMemberCase(): ?MemberCase
    {
        return $this->memberCase;
    }

    public function setMemberCase(?MemberCase $memberCase): static
    {
        $this->memberCase = $memberCase;

        return $this;
    }

    public function getDate(): ?\DateTimeInterface
    {
        return $this->date;
    }

    public function setDate(\DateTimeInterface $date): static
    {
        $this->date = $date;

        return $this;
    }

    public function getNextVisit(): ?\DateTimeInterface
    {
        return $this->nextVisit;
    }

    public function setNextVisit(\DateTimeInterface $nextVisit): static
    {
        $this->nextVisit = $nextVisit;

        return $this;
    }
}
