<?php

namespace App\Entity\Case;

use App\Repository\Case\StandardNoteMemberRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Types\UuidType;
use Symfony\Component\Uid\Uuid;

#[ORM\Entity(repositoryClass: StandardNoteMemberRepository::class)]
class StandardNoteMember
{
    #[ORM\Id]
    #[ORM\Column(type: UuidType::NAME, unique: true)]
    #[ORM\GeneratedValue(strategy: 'CUSTOM')]
    #[ORM\CustomIdGenerator(class: 'doctrine.uuid_generator')]
    private ?Uuid $id = null;

    #[ORM\ManyToOne]
    #[ORM\JoinColumn(nullable: false)]
    private ?StandardNote $note = null;

    #[ORM\ManyToOne]
    #[ORM\JoinColumn(nullable: false)]
    private ?Member $person = null;

    public function getId(): ?Uuid
    {
        return $this->id;
    }

    public function getStandardNote(): ?StandardNote
    {
        return $this->note;
    }

    public function setStandardNote(?StandardNote $note): static
    {
        $this->note = $note;

        return $this;
    }

    public function getPerson(): ?Member
    {
        return $this->person;
    }

    public function setPerson(?Member $person): static
    {
        $this->person = $person;

        return $this;
    }
}
